"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _rax = require("rax");

var _universalEnv = require("universal-env");

var _raxTouchable = _interopRequireDefault(require("rax-touchable"));

var _raxText = _interopRequireDefault(require("rax-text"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var Picker =
/*#__PURE__*/
function (_Component) {
  _inherits(Picker, _Component);

  function Picker(props) {
    var _this;

    _classCallCheck(this, Picker);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(Picker).call(this, props));

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "getPickerData", function () {
      var _this$props = _this.props,
          children = _this$props.children,
          selectedValue = _this$props.selectedValue;
      var pickerItems = [],
          pickerLabelList = [],
          items = [],
          selectIndex = 0,
          selectedLabel;

      if (children.length) {
        pickerItems = children;
      } else {
        pickerItems = [children];
      }

      pickerLabelList = pickerItems.map(function (item, index) {
        var _item$props = item.props,
            value = _item$props.value,
            label = _item$props.label,
            color = _item$props.color;
        items.push({
          value: value,
          label: label || value
        });

        if (value == selectedValue) {
          selectIndex = index;
          selectedLabel = label;
        }

        return label;
      });
      return {
        selectIndex: selectIndex,
        selectedLabel: selectedLabel,
        pickerLabelList: pickerLabelList,
        items: items
      };
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "getPickerDataByIndex", function (index, pickerData) {
      return {
        value: pickerData.items[index].value,
        label: pickerData.items[index].label
      };
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "getPickerLableByValue", function (value, pickerData) {
      var label = '';

      for (var i = 0; i < pickerData.items.length; i++) {
        if (pickerData.items[i].value == value) {
          label = pickerData.items[i].label;
        }
      }

      return label;
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "handlePress", function (webIndex) {
      var _this$props2 = _this.props,
          onValueChange = _this$props2.onValueChange,
          selectedValue = _this$props2.selectedValue;

      var pickerData = _this.getPickerData();

      if (_universalEnv.isWeex) {
        var picker = __weex_require__('@weex-module/picker');

        picker.pick({
          index: pickerData.selectIndex,
          items: pickerData.pickerLabelList
        }, function (event) {
          if (event.result === 'success') {
            var index = event.data;

            var _this$getPickerDataBy = _this.getPickerDataByIndex(index, pickerData),
                value = _this$getPickerDataBy.value;

            onValueChange && onValueChange(value, index);
          }
        });
      } else {
        var _this$getPickerDataBy2 = _this.getPickerDataByIndex(webIndex, pickerData),
            value = _this$getPickerDataBy2.value;

        onValueChange && onValueChange(value, webIndex);
      }
    });

    var _pickerData = _this.getPickerData();

    return _this;
  }

  _createClass(Picker, [{
    key: "render",
    value: function render() {
      var _this2 = this;

      var selectedValue = this.props.selectedValue;
      var pickerData = this.getPickerData();
      var selectedLabel = this.getPickerLableByValue(selectedValue, pickerData);

      var style = _objectSpread({}, styles.initial, this.props.style);

      var textStyle = {
        color: style.color,
        fontSize: style.fontSize,
        fontStyle: style.fontStyle,
        fontWeight: style.fontWeight,
        textAlign: style.textAlign,
        textDecoration: style.textDecoration,
        textOverflow: style.textOverflow,
        lineHeight: style.lineHeight
      };

      if (_universalEnv.isWeex) {
        return (0, _rax.createElement)(_raxTouchable.default, _extends({}, this.props, {
          onPress: this.handlePress,
          style: style
        }), (0, _rax.createElement)(_raxText.default, {
          style: textStyle
        }, selectedLabel));
      } else {
        var _pickerData2 = this.getPickerData();

        return (0, _rax.createElement)("select", {
          style: style,
          onChange: function onChange(e) {
            _this2.handlePress(e.target.options.selectedIndex);
          }
        }, _pickerData2.items.map(function (item, index) {
          if (index == _pickerData2.selectIndex) {
            return (0, _rax.createElement)("option", {
              selected: "selected",
              value: item.value
            }, item.label);
          } else {
            return (0, _rax.createElement)("option", {
              value: item.value
            }, item.label);
          }
        }));
      }
    }
  }]);

  return Picker;
}(_rax.Component);

_defineProperty(Picker, "propTypes", {});

var Item =
/*#__PURE__*/
function (_Component2) {
  _inherits(Item, _Component2);

  function Item() {
    _classCallCheck(this, Item);

    return _possibleConstructorReturn(this, _getPrototypeOf(Item).apply(this, arguments));
  }

  _createClass(Item, [{
    key: "render",
    value: function render() {
      return null;
    }
  }]);

  return Item;
}(_rax.Component);

;
Picker.Item = Item;
var styles = {
  initial: {
    display: 'flex',
    justifyContent: 'center',
    flexDirection: 'row'
  }
};
var _default = Picker;
exports.default = _default;
module.exports = exports["default"];